SystemOrganization addCategory: #MyProject!

TestCase subclass: #ListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyProject'!

!ListTest commentStamp: 'Honorem 7/18/2018 21:04' prior: 0!
Class use to test list methods.!

!ListTest methodsFor: 'tests' stamp: 'Honorem 7/18/2018 21:12'!
testList
|maListe|
maListe :=ElmtList new.
maListe addElmt: '2eme element'.
maListe addElmt: '1er element'.
self assert: maListe getElement equals: '1er element'.! !

!ListTest methodsFor: 'tests' stamp: 'Honorem 7/18/2018 21:19'!
testRemoveList
|maListe|
maListe :=ElmtList new.
self assert:  maListe removehead equals:'cannot remove from empty list' .
maListe addElmt: '2eme element'.
maListe addElmt: '1er element'.
maListe removehead .
self assert: maListe getElement equals: '2eme element'.
! !

!ListTest methodsFor: 'tests' stamp: 'Honorem 7/18/2018 21:15'!
testaddElmtHeadList
|maListe|
maListe :=ElmtList new.
maListe addElmt: '2eme element'.
maListe addElmt: '1er element'.
self assert: maListe getElement equals: '1er element'.
self assert: maListe getNext equals: '2eme element'.! !

Object variableSubclass: #DocGenerator
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyProject'!

!DocGenerator commentStamp: 'Honorem 7/20/2018 23:09' prior: 0!
For the docu generator, th decumentation is very basic. 
Use:
DocGenerator generatDoc: className and it will create the documentation file in pharo local directory. !

!DocGenerator class methodsFor: 'utilities' stamp: 'Honorem 7/20/2018 23:55'!
generatDoc: anObject
|temp docName fileBegin fileEnd streamfile|
docName :=anObject className .
fileBegin :='<!!DOCTYPE html>
<html>
<head>
<link href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.2/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Smlep5jCw/wG7hdkwQ/Z5nLIefveQRIY9nfy6xoR1uRYBtpZgI6339F5dgvm/e9B" crossorigin="anonymous">
<title>Documentation ',(docName asLowercase ), '</title>
</head>
<body>
<center>
<div class="lead"><h2>',docName ,' documentation</h2></div></center>
<div class="btn btn-success text-center">Methods</div>'.
fileEnd :='

</body>
</html>'.
temp :=anObject  class methods collect: [ :each| each sourceCode  ].
streamfile:=(docName ,'.html') asFileReference writeStream .
streamfile nextPutAll: fileBegin;cr .  
temp 
do: [:each|
	streamfile nextPutAll: '<hr class="row"/> ' ;cr.
	streamfile nextPutAll: '<div class="container alert alert-primary">' ;cr.
	streamfile nextPutAll: each ;cr.
	streamfile nextPutAll: '</div>' ].
streamfile nextPutAll: fileEnd .
streamfile close .
! !

!DocGenerator methodsFor: 'accessing' stamp: 'Honorem 7/20/2018 21:37'!
content
	^ content! !

!DocGenerator methodsFor: 'accessing' stamp: 'Honorem 7/20/2018 21:37'!
content: anObject
	content := anObject! !

Object subclass: #Element
	instanceVariableNames: 'data next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyProject'!

!Element commentStamp: 'Honorem 7/15/2018 14:47' prior: 0!
class to creat each element of the linked list .!

!Element methodsFor: 'accessing' stamp: 'Honorem 7/15/2018 14:48'!
data
	^ data! !

!Element methodsFor: 'accessing' stamp: 'Honorem 7/15/2018 14:48'!
data: anObject
	data := anObject! !

!Element methodsFor: 'accessing' stamp: 'Honorem 7/15/2018 14:48'!
next
	^ next! !

!Element methodsFor: 'accessing' stamp: 'Honorem 7/15/2018 14:48'!
next: anObject
	next := anObject! !

Object subclass: #ElmtList
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyProject'!

!ElmtList commentStamp: 'Honorem 7/17/2018 23:52' prior: 0!
blabla!

!ElmtList methodsFor: 'add/remove' stamp: 'Honorem 7/18/2018 00:12'!
addElmt: anObject
|tempElmt|
tempElmt :=Element new .
tempElmt data: anObject .
self head isNil   
ifTrue: 
[ 
 tempElmt next: nil .
	 ]
ifFalse: [ 
	tempElmt next: head .
	 ] .
self head: tempElmt .
^self .! !

!ElmtList methodsFor: 'add/remove' stamp: 'Honorem 7/18/2018 00:40'!
addElmtBack: anObject
|tempElmt e|
tempElmt :=Element new .
tempElmt data: anObject .
(self head isNotNil )    
ifTrue:  
[ 
	tempElmt next: self head .
	
  [(self head next  isNotNil)] whileTrue: [ 
	self head: self head next .
	 ].
e:=tempElmt next .
tempElmt next: nil.
self head next: tempElmt .
"elf head next next: nil."
self head: e .
^self 
	 ]
ifFalse: [ 
	tempElmt next: nil .
	self head: tempElmt .
	 ] .

^self .! !

!ElmtList methodsFor: 'accessing' stamp: 'Honorem 7/18/2018 00:44'!
getElement
self head isNotNil 
ifTrue: [ 
	^self head data.
	 ]
ifFalse:[
^'Empty list'.	].! !

!ElmtList methodsFor: 'accessing' stamp: 'Honorem 7/18/2018 00:51'!
getNext
self head isNotNil & self head next isNotNil 
ifTrue: [ 
	^self head next data.
	 ]
ifFalse:[
^'No next element !!!!'.	].! !

!ElmtList methodsFor: 'accessing' stamp: 'Honorem 7/15/2018 23:33'!
head
	^ head! !

!ElmtList methodsFor: 'accessing' stamp: 'Honorem 7/15/2018 23:33'!
head: anObject
	head := anObject! !

!ElmtList methodsFor: 'add/remove' stamp: 'Honorem 7/18/2018 20:43'!
removehead
|tempelmnt|
self head isNil 
ifTrue: [ 
	^'cannot remove from empty list'.
	 ]
ifFalse:[
	tempelmnt:=self head next.
	self head next:nil.
	self head: tempelmnt .
	].
^self.! !
